﻿Import-Module "$PSScriptRoot\NtApi"
$file = $null
$process = $null
$section = $null

try
{
    $ntpath = "\??\" + $PSScriptRoot + "\bin\demo.exe"
    $file = [NtApi.NtSystemCalls]::OpenFile($ntpath, "MaximumAllowed", "Read, Delete", "NonDirectoryFile", $false);
    $section = [NtApi.NtSystemCalls]::CreateImageSection($file)
    $process = [NtApi.NtSystemCalls]::CreateProcessEx($section)
    $result = "Created Process: " + [NtApi.NtSystemCalls]::GetProcessImageName($process, $false)
    Write-Host $result
}
catch
{
    Write-Host $_.Exception.Message
}
finally
{
    if ($file -ne $null)
    {
        $file.Dispose()
    }
    if ($section -ne $null)
    {
        $section.Dispose()
    }
    if ($process -ne $null)
    {
        [NtApi.NtSystemCalls]::NtTerminateProcess($process.DangerousGetHandle(), 0)
        $process.Close()
    }
}