﻿Import-Module "$PSScriptRoot\NtApi"
$processes = [NtApi.NtSystemCalls]::GetProcesses("QueryLimitedInformation")

try
{
    foreach($process in $processes)
    {
        $exitstatus = [NtApi.NtSystemCalls]::GetProcessExitStatus($process)
        if ($exitstatus -eq 259)
        {
            continue
        }
        $processid = [NtApi.NtSystemCalls]::GetProcessId($process)
        $sessionid = [NtApi.NtSystemCalls]::GetProcessSessionId($process)
        #$imagename = [NtApi.NtSystemCalls]::GetProcessImageName($process, $false)
        Write-Host $exitstatus, $processid, $sessionid
    }
}
catch
{
    Write-Host $_.Exception.Message
}
finally
{
    if ($pinfo -ne $null)
    {
        $pinfo.Dispose();
    }

    foreach($process in $processes)
    {
        $process.Close()
    }
}