﻿Import-Module "$PSScriptRoot\NtApi"
$pinfo = $null

try
{
    $config = New-Object NtApi.CreateUserProcess
    $config.ImagePath = "C:\Windows\Notepad.exe"
    $config.CommandLine = "notepad"
    $config.ThreadFlags = "Suspended"

    $srcpath = $PSScriptRoot + "\bin\demo.exe"    
    $destpath = $PSScriptRoot + "\bin\notepad.exe"
    copy $srcpath $destpath

    $pinfo = $config.Start("\??\" + $destpath)
    Write-Host "Created Process:", $pinfo.GetProcessImageName($false), "PID: ", $pinfo.ClientId.UniqueProcess
    $pinfo.Resume() | Out-Null

    Get-WmiObject -Query 'select * from win32_process where Name = ''notepad.exe''' | Select-Object -Property ProcessId, Path, CommandLine
}
catch
{
    Write-Host $_.Exception.Message
}
finally
{
    if ($pinfo -ne $null)
    {
        $pinfo.Dispose();
    }
}